// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package protointeraction

import (
	context "context"
	common "gitlab.com/vajar_minigame/proto_go/gen/common"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// InteractionServiceClient is the client API for InteractionService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type InteractionServiceClient interface {
	MonsterConsumeItem(ctx context.Context, in *MonConsumeItemRequest, opts ...grpc.CallOption) (*common.ResponseStatus, error)
	UserConsumeItem(ctx context.Context, in *UserConsumeItemRequest, opts ...grpc.CallOption) (*common.ResponseStatus, error)
}

type interactionServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewInteractionServiceClient(cc grpc.ClientConnInterface) InteractionServiceClient {
	return &interactionServiceClient{cc}
}

func (c *interactionServiceClient) MonsterConsumeItem(ctx context.Context, in *MonConsumeItemRequest, opts ...grpc.CallOption) (*common.ResponseStatus, error) {
	out := new(common.ResponseStatus)
	err := c.cc.Invoke(ctx, "/protointeraction.InteractionService/MonsterConsumeItem", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *interactionServiceClient) UserConsumeItem(ctx context.Context, in *UserConsumeItemRequest, opts ...grpc.CallOption) (*common.ResponseStatus, error) {
	out := new(common.ResponseStatus)
	err := c.cc.Invoke(ctx, "/protointeraction.InteractionService/UserConsumeItem", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// InteractionServiceServer is the server API for InteractionService service.
// All implementations must embed UnimplementedInteractionServiceServer
// for forward compatibility
type InteractionServiceServer interface {
	MonsterConsumeItem(context.Context, *MonConsumeItemRequest) (*common.ResponseStatus, error)
	UserConsumeItem(context.Context, *UserConsumeItemRequest) (*common.ResponseStatus, error)
	mustEmbedUnimplementedInteractionServiceServer()
}

// UnimplementedInteractionServiceServer must be embedded to have forward compatible implementations.
type UnimplementedInteractionServiceServer struct {
}

func (UnimplementedInteractionServiceServer) MonsterConsumeItem(context.Context, *MonConsumeItemRequest) (*common.ResponseStatus, error) {
	return nil, status.Errorf(codes.Unimplemented, "method MonsterConsumeItem not implemented")
}
func (UnimplementedInteractionServiceServer) UserConsumeItem(context.Context, *UserConsumeItemRequest) (*common.ResponseStatus, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UserConsumeItem not implemented")
}
func (UnimplementedInteractionServiceServer) mustEmbedUnimplementedInteractionServiceServer() {}

// UnsafeInteractionServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to InteractionServiceServer will
// result in compilation errors.
type UnsafeInteractionServiceServer interface {
	mustEmbedUnimplementedInteractionServiceServer()
}

func RegisterInteractionServiceServer(s grpc.ServiceRegistrar, srv InteractionServiceServer) {
	s.RegisterService(&InteractionService_ServiceDesc, srv)
}

func _InteractionService_MonsterConsumeItem_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(MonConsumeItemRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(InteractionServiceServer).MonsterConsumeItem(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/protointeraction.InteractionService/MonsterConsumeItem",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(InteractionServiceServer).MonsterConsumeItem(ctx, req.(*MonConsumeItemRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _InteractionService_UserConsumeItem_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UserConsumeItemRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(InteractionServiceServer).UserConsumeItem(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/protointeraction.InteractionService/UserConsumeItem",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(InteractionServiceServer).UserConsumeItem(ctx, req.(*UserConsumeItemRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// InteractionService_ServiceDesc is the grpc.ServiceDesc for InteractionService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var InteractionService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "protointeraction.InteractionService",
	HandlerType: (*InteractionServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "MonsterConsumeItem",
			Handler:    _InteractionService_MonsterConsumeItem_Handler,
		},
		{
			MethodName: "UserConsumeItem",
			Handler:    _InteractionService_UserConsumeItem_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "interactions.proto",
}
